# pylint: disable=missing-module-docstring
# pylint: disable=missing-function-docstring
# pylint: disable=missing-class-docstring
from enum import Enum


class Action(Enum):

   # NO ACTION (0)
    UNKNOWN=0
    NOTSET = 1
    NO_ACTION = 2
    
    # READ ACTIONS (1000-1999)
    READ = 1000
    READ_STREAM = 1001
    READ_QUERY = 1010
    READ_FILE = 1020
    READ_HTTP_GET = 1030
    READ_SECRET = 1040
    READ_SCHEMA = 1045
    READ_PULL_MESSAGE = 1050
    READ_PUSH_MESSAGE = 1070
    READ_PUBLISHED_MESSAGE = 1075
    READ_LIST_SUBSCRIPTIONS = 1080
    READ_LIST_TOPICS = 1090
    READ_LIST_MESSAGES = 1100
    READ_LIST_FILES = 1110
    READ_LIST_TABLES = 1120
    READ_LIST_COLLECTIONS = 1130
    READ_LIST_DOCUMENTS = 1140
    READ_AUTHZ = 1170
    READ_AUTHZ_LIST_PERMISSIONS = 1171
    READ_AUTH_LIST_USERS = 1180
    READ_AUTH_GET_USER = 1181
    READ_AUTH_LIST_GROUPS = 1185

    # VALIDATE AND AUTHORIZATION ACTIONS (2000-2999)
    VALIDATE = 2000
    VALIDATE_AGAINST_SCHEMA= 2021
    VALIDATE_ATTRIBUTES = 2025


    VALIDATE_AUTHZ_ALLOWED = 2210
    VALIDATE_AUTHZ_DENIED = 2220
    VALIDATE_AUTH_PASSWORD_CORRECT = 2300
    VALIDATE_AUTH_USER_TOKEN = 2310

    # CALCULATE ACTIONS (3000-3999)
    CALCULATE = 3000
    CALCULATE_STATISTICS = 3050
    CALCULATE_METRICS = 3060
    CALCULATE_FEATURES = 3070
    CALCULATE_TRAIN = 3080
    CALCULATE_EVALUATE = 3090
    CALCULATE_DERIVED_FIELDS = 3100
    CALCULATE_CLASSIFICATION = 3110
    CALCULATE_CLUSTERING = 3120
    CALCULATE_PREDICTION = 3130
    CALCULATE_ANOMALY_DETECTION = 3140
    CALCULATE_SIMULATION = 3150
    
   # TRANSFORM ACTIONS (4000-4999)
    TRANSFORM = 4000
    TRANSFORM_JSON_LOADS = 4005
    TRANSFORM_JSON_DUMPS = 4006
    TRANSFORM_JSON_LOAD = 4007
    TRANSFORM_JSON_DUMP = 4008
    TRANSFORM_PREPROCESS = 4010
    TRANSFORM_FILTER = 4020
    TRANSFORM_SORT = 4030
    TRANSFORM_UNION = 4040
    TRANSFORM_JOIN = 4050
    TRANSFORM_MERGE = 4060
    TRANSFORM_SPLIT = 4070
    TRANSFORM_GROUP = 4080
    TRANSFORM_GROUP_BY = 4090
    TRANSFORM_AGGREGATE = 4100
    TRANSFORM_NORMALIZE = 4110
    TRANSFORM_DENORMALIZE = 4120
    TRANSFORM_DEDUPLICATE = 4130
    TRANSFORM_DECRYPT = 4140
    TRANSFORM_ENCRYPT = 4150
    TRANSFORM_MASK = 4160
    TRANSFORM_SYNC = 4170
    TRANSFORM_ADD_VALUES = 4180
    TRANSFORM_FILL_MISSING_VALUES = 4190
    TRANSFORM_REPLACE_VALUES = 4200
    TRANSFORM_REPLACE = 4210
    TRANSFORM_RENAME = 4220
    TRANSFORM_INCREMENT = 4230
    TRANSFORM_ANONYMIZE = 4240

    # PERSIST ACTIONS (5000-5999)
    PERSIST = 5000
    PERSIST_BATCH=5001
    # HTTP Persist
    PERSIST_HTTP_POST = 5010
    PERSIST_HTTP_PUT = 5020
    PERSIST_HTTP_PATCH = 5030
    PERSIST_HTTP_DELETE = 5040
    PERSIST_HTTP_OPTIONS = 5050
    
    # Generic Persist for Files, Tables, Collections, Databases
    PERSIST_WRITE = 5060
    PERSIST_WRITE_BATCH = 5061
    PERSIST_WRITE_QUERY = 5062
    PERSIST_WRITE_STREAM = 5063
    PERSIST_WRITE_FILE = 5064
    PERSIST_EXPORT_FILE_QUERY = 5064
    PERSIST_CREATE = 5070
    PERSIST_CREATE_BATCH = 5071
    PERSIST_CREATE_TABLE = 5072
    PERSIST_CREATE_TABLE_TEMP = 5073
    PERSIST_CREATE_OR_REPLACE_TABLE = 5074
    PERSIST_CREATE_OR_REPLACE_TABLE_TEMP = 5074
    PERSIST_CREATE_OR_LOAD_TABLE_FROM_JSON = 5075
    PERSIST_CREATE_OR_LOAD_TABLE_FROM_JSON_TEMP = 5076
    PERSIST_CREATE_DATABASE = 5080
    PERSIST_CREATE_COLLECTION = 5081
    PERSIST_UPDATE = 5090
    PERSIST_UPDATE_BATCH = 5091
    
    PERSIST_INSERT = 5100
    PERSIST_INSERT_BATCH = 5101
    PERSIST_MERGE = 5110
    PERSIST_MERGE_BATCH = 5113
    PERSIST_MERGE_QUERY = 5115
    PERSIST_MERGE_UPDATE_AND_INSERT_NEW_QUERY = 5116
    PERSIST_MERGE_UPDATE_DONT_INSERT_NEW_QUERY = 5117
    PERSIST_MERGE_INSERT_NEW_AND_DONT_UPDATE_QUERY = 5118
    PERSIST_MERGE_DOCUMENT = 5121
    PERSIST_RENAME = 5125
    PERSIST_RENAME_BATCH = 5126
    PERSIST_MOVE = 5130
    PERSIST_MOVE_BATCH = 5131
    PERSIST_COPY = 5140
    PERSIST_COPY_BATCH = 5141
    PERSIST_APPEND = 5150
    PERSIST_APPEND_BATCH = 5151
    PERSIST_UPSERT = 5160
    PERSIST_UPSERT_BATCH = 5161
    PERSIST_BACKUP = 5170
    PERSIST_RESTORE = 5175

    PERSIST_DELETE = 5200
    PERSIST_DELETE_BATCH = 5210
    PERSIST_DELETE_TABLE = 5220
    PERSIST_DELETE_TABLE_TEMP = 5225
    PERSIST_DELETE_DATABASE = 5230
    PERSIST_DELETE_COLLECTION = 5235
    PERSIST_DELETE_FILE= 5240
    PERSIST_ARCHIVE = 5270

    #Messaging Actions (5300-5399)
    PERSIST_PUBLISH_MESSAGE = 5400
    PERSIST_ACK_MESSAGE = 5405
    PERSIST_CREATE_TOPIC = 5410
    PERSIST_DELETE_TOPIC = 5415
    PERSIST_CREATE_SUBSCRIPTION = 5420
    PERSIST_DELETE_SUBSCRIPTION = 5425


    # IAM Actions (5400-5565)
    PERSIST_AUTHZ_SET_PERMISSIONS = 5500
    PERSIST_AUTHZ_SET_USER_PERMISSIONS = 5505
    PERSIST_AUTHZ_SET_GROUP_PERMISSIONS = 5510
    PERSIST_AUTHZ_SET_ROLE_PERMISSIONS = 5515
    PERSIST_AUTH_REGISTER_USER = 5520
    PERSIST_AUTH_DELETE_USER = 5525
    PERSIST_AUTH_RESET_PASSWORD = 5530
    PERSIST_AUTH_CHANGE_PASSWORD = 5535
    PERSIST_AUTH_UPDATE_USER = 5540
    PERSIST_AUTH_CREATE_GROUP = 5545
    PERSIST_AUTH_DELETE_GROUP = 5550
    PERSIST_AUTH_UPDATE_GROUP = 5555

    # EXECUTE ACTIONS (7000-7999)
    EXECUTE = 7000

    def __str__(self):
        return self.name

class ControlAction(Enum):

 # --- CONTROL ACTIONS ---
    CONTROL_START = "control_start"
    CONTROL_BOOT = "control_boot"
    CONTROL_STOP = "control_stop"
    CONTROL_PAUSE = "control_pause"
    CONTROL_RESUME = "control_resume"
    CONTROL_RESTART = "control_restart"
    CONTROL_RELOAD = "control_reload"
    CONTROL_SHUTDOWN = "control_shutdown"
    CONTROL_REBOOT = "control_reboot"
    CONTROL_VERIFY = "control_verify"
    CONTROL_RECOVER = "control_recover"
    CONTROL_SKIP= "control_skip"
    CONTROL_CANCEL = "control_cancel"

    def __str__(self):
        return self.name