
# pylint: disable=missing-module-docstring
# pylint: disable=missing-function-docstring
# pylint: disable=missing-class-docstring
from enum import Enum



class Alert(Enum):

    UNKNOWN = 0
    # NOTICE ALERTS (1000-1999)
    # Authentication/Authorization (1000-1099)
    AUTHZ_PERMISSION_GRANTED = 1000
    AUTHZ_PERMISSION_DENIED = 1005
    AUTHZ_PERMISSION_REVOKED = 1010
    AUTHZ_ACTION_ALLOWED = 1015
    AUTHZ_ACTION_DENIED = 1020
    AUTHZ_RESOURCE_ALLOWED = 1025
    AUTHZ_RESOURCE_DENIED = 1030
    AUTH_SUCCESS = 1035
    AUTH_FAILURE = 1040

    # Data Existence (1100-1199)
    ALREADY_EXISTS = 1100
    RESOURCE_ALREADY_EXISTS = 1102
    FILE_ALREADY_EXISTS = 1105
    USER_ALREADY_EXISTS = 1107
    DATA_ALREADY_EXISTS = 1110
    DATA_PARTIALLY_EXISTS = 1115
    RECORD_ALREADY_EXISTS = 1120
    RECORDS_ALREADY_EXIST = 1125
    RECORDS_PARTIALLY_EXIST = 1130
    DOCUMENT_ALREADY_EXISTS = 1135

    # NOTICE OR WARNING ALERTS (2000-2299)
    # Data Availability (2200-2299)
    NOT_FOUND=2200
    RESOURCE_NOT_FOUND = 2202
    TABLE_NOT_FOUND = 2205
    TABLES_NOT_FOUND = 2206
    TABLE_EMPTY = 2210
    DB_NOT_FOUND = 2215
    COLLECTION_NOT_FOUND = 2220
    COLLECTION_EMPTY = 2225
    DOCUMENT_NOT_FOUND = 2230
    FILE_NOT_FOUND = 2235
    FILES_NOT_FOUND = 2240
    FILE_EMPTY = 2245

    # WARNING ALERTS (3000-3999)
    # System Performance
    SYSTEM_MEMORY_USAGE_HIGH = 3100
    SYSTEM_CPU_USAGE_HIGH = 3110
    SYSTEM_NETWORK_SPEED_SLOW = 3120
    SYSTEM_DISK_SPACE_LOW = 3130
    SYSTEM_THROUGHPUT_LOW = 3140

    # WARNING OR ERROR ALERTS (4000-4999)
    SYSTEM_CONCURRENCY_LIMIT = 4100
    SYSTEM_CONNECTIONS_LIMIT = 4110
    SERVICE_RESPONSE_TIME_LIMIT = 4130

    # ERROR ALERTS (5000-5999)

    # System Errors (5000-5099)
    SERVICE_UNRESPONSIVE = 5000
    SERVICE_TIMEOUT = 5005
    SERVICE_ISSUES_THRESHOLD_REACHED = 5010
    SYSTEM_ISSUES_THRESHOLD_LIMIT = 5015
    SYSTEM_EARLY_TERMINATION = 5020

    # CONTENT ISSUES (5100-5199)
    DATA_VALIDATION_ISSUES = 5100
    VALIDATION_ISSUE = 5105
    SCHEMA_VALIDATION_ISSUES = 5110
    SCHEMA_ISSUE = 5115
    DATA_ISSUE = 5120
    DATA_ISSUES = 5125
    METADATA_ISSUE = 5130
    METADATA_ISSUES = 5135
    ALLOWED_ISSUES_THRESHOLD_REACHED = 5140

    # CRITICAL ALERTS (4000-6999)
    # System Critical (6000-6099)
    SYSTEM_OUT_OF_MEMORY = 6000
    SYSTEM_CPU_LIMIT_REACHED = 6005
    SYSTEM_DISK_SPACE_FULL = 6010
    SYSTEM_NETWORK_UNAVAILABLE = 6015

    # System Crashes (6100-6199)
    SYSTEM_PROCESSOR_CRASH = 6100
    SYSTEM_CRASH = 6105
    SYSTEM_CONTAINER_CRASH = 6110
    SYSTEM_SERVICE_CRASH = 6115

    def __str__(self):
        return self.name